<template>
  <v-app id="app">
    <v-navigation-drawer v-model="drawer" clipped app>
      <v-list>
        <v-subheader class="subtitle-1">Compliance Frameworks</v-subheader>
        <v-list-item-group>
          <v-list-item v-for="(item, i) in nav" :key="i" :to="item.to" dense>
            <v-list-item-icon dense class="mr-4"><v-icon>{{ item.icon }}</v-icon></v-list-item-icon>
            <v-list-item-content class="body-2">{{ item.text }}</v-list-item-content>
          </v-list-item>
        </v-list-item-group>
      </v-list>
      <template v-slot:append>
        <v-list>
          <v-list-item dense :href="projectURL" target="_blank">
            <v-list-item-icon dense class="mr-4"><v-icon>mdi-open-in-new</v-icon></v-list-item-icon>
            <v-list-item-content class="body-2">View this tool on GitLab</v-list-item-content>
          </v-list-item>
        </v-list>
      </template>
    </v-navigation-drawer>
    <v-app-bar
      app
      dense
      elevation="1"
      color="white"
      clipped-left
      >
      <v-app-bar-nav-icon @click="drawer = !drawer"></v-app-bar-nav-icon>
      <div class="d-flex align-center pa-0">
        <Tanuki :loading='false'></Tanuki>
      </div>
      <v-toolbar-title class="pl-1">Compliance Toolkit {{ !$vuetify.breakpoint.xsOnly ? 'for GitLab' : '' }}</v-toolbar-title>

      <v-spacer></v-spacer>
      <v-btn class="ma-2" elevation="0" color="primary" small :disabled="!isAuthenticated" @click="logout(vueInstance)">Logout</v-btn>
    </v-app-bar>
    <v-main class="grey lighten-3">
      <v-container>
        <v-row>
          <v-col cols="12">
            <keep-alive>
              <router-view v-if="isAuthenticated && !authRefreshing"/>
            </keep-alive>
          </v-col>
        </v-row>
      </v-container>

      <v-dialog
        v-model="dialog"
        persistent
        max-width="290"
      >
        <v-card>
          <v-card-title class="headline justify-center">
              <Tanuki :loading='loading' :size="80"></Tanuki>
          </v-card-title>
          <v-card-actions class="pb-4">
            <v-spacer></v-spacer>
            <v-btn
              color="blue darken-4"
              outlined
              text
              @click="authenticate(vueInstance)"
            >
              Authenticate With GitLab
            </v-btn>
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-main>
  </v-app>
</template>

<style src='@koumoul/vjsf/lib/VJsf.css'></style>
<style src='@koumoul/vjsf/dist/main.css'></style>
<style scoped>
.nav .v-list-item--active {
  font-weight: bold;
  text-decoration-color: var(--v-primary-base);
}
</style>

<script lang="ts">
import { Component, Vue, Watch } from 'vue-property-decorator'
import { Getter, Action, State } from 'vuex-class'
import { getProjectURL } from './gitlab'
import Tanuki from './components/Tanuki.vue'
import log from 'loglevel'

@Component({
  components: { Tanuki }
})
export default class App extends Vue {
  @State token!: string
  @Getter isAuthenticated!: boolean
  @Getter loading!: boolean
  @Action authenticate!: (vue: any) => void
  @Action refresh!: (vue: any) => void
  @Action logout!: (vue: any) => void

  ffNavDrawer = true
  drawer = true
  projectURL = getProjectURL()

  nav = [
    { text: 'Audit Framework Assignments', icon: 'mdi-chart-box-outline', to: '/audit' },
    { text: 'Import Project Framework Assignments', icon: 'mdi-file-import-outline', to: '/import' },
    { text: 'Apply a Framework to Projects in a Group', icon: 'mdi-playlist-check', to: '/apply' }
    // { text: 'Copy Framework Definitions Across Groups', icon: 'mdi-cog', to: '/copy' }
  ]

  // The Gitbeaker component uses 'ky' for API operations, which doesn't have any
  // handlers set up to get a refresh token on expiration. This function ensures a
  // token is refreshed hourly so that library always has a valid token
  @Watch('token')
  onTokenChanged (val: string): void {
    if (val !== '' && this.authRefreshing) {
      this.authRefreshing = false
    }

    // Set refresh to 10min before expiration. If no expiration found
    // assume 1 hr in the future
    const expiration = ((this.$auth as any).getExpiration() || 3600) * 1000
    log.debug(`Token Expiration: ${expiration}`)
    const refreshIn = expiration - Date.now() - (10 * 60 * 1000)
    log.debug(`Refresh Token In: ${refreshIn}`)
    setTimeout(this.triggerRefresh, refreshIn)
  }

  triggerRefresh (): void {
    log.debug('Refreshing token')
    this.refresh(this)
  }

  authRefreshing = true;

  created (): void {
    if (this.isAuthenticated) {
      this.refresh(this)
    } else {
      this.authRefreshing = false
    }

    const logLevel = this.$route?.query?.log as string
    if (logLevel) {
      switch (logLevel) {
        case 'trace': log.setLevel(log.levels.TRACE)
          break
        case 'debug': log.setLevel(log.levels.DEBUG)
          break
        case 'info': log.setLevel(log.levels.INFO)
          break
        case 'warn': log.setLevel(log.levels.WARN)
          break
        case 'error': log.setLevel(log.levels.ERROR)
          break
      }
    }
  }

  get dialog (): boolean {
    return !this.isAuthenticated
  }

  get vueInstance (): Vue {
    return this
  }
}
</script>
